#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Die Insert-Funktion soll beliebige Datenstrukturen (nicht nur */
/* Studentenstructs) in den Baum einfuegen koennen. Im ersten */
/* Schritt wird hierzu eine neue Struktur Studenten angelegt, */
/* auf die ueber den Baum zugegriffen werden kann (struct */
/* studenten students). */

struct studenten {
	int matrnr;
	char name[100];
};

struct tree {
	struct studenten students;
	struct tree *left;
	struct tree *right;
};

void insert(struct tree * *t, struct studenten s) {
	if ((*t) == NULL) {
		(*t) = (struct tree*)calloc(sizeof(struct tree), 1);
		(*t)->students = s;
		(*t)->left = NULL;
		(*t)->right = NULL;
	}
	else if (s.matrnr <= ((*t)->students).matrnr) {
		insert(&((*t)->left), s);
	}
	else {
		insert(&((*t)->right), s);
	}
}

void print(struct tree *t) {
	if (t != NULL) {
		print(t->left);
        printf("%d:", t->students.matrnr);
        printf("%s", t->students.name);
		print(t->right);
	}
}

int main() {

	struct tree *root = NULL;

	struct studenten studis;

    char *token;
    char buf[30];
    FILE *fp = NULL;
	int counter = 0;

    if (!(fp = fopen("studis.txt", "r"))) {
        fprintf(stderr, "ERROR: FILE OPEN");
        return 1;
    }

    while (fgets(buf, 30, fp) > 0) {
        token = strtok(buf, ":");
        sscanf(token, "%d", &(studis.matrnr));
        token = strtok(NULL, ":");
        strcpy(studis.name, token);
        insert(&root, studis);
		counter++;
    }

    printf("Nach Matrikelnummer sortiert:\n");

	print(root);

	return 0;

}
