#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Zunaechst sollte die Struktur tree unabhaenig von der Struktur */
/* studenten sein. Hierzu wird im Baum ein void Pointer element, */
/* der auf beliebige Strukturen zeigen kann, eingefuehrt. Allerdings */
/* muess in der Insert-Funktion im Moment noch oft auf die Studenten */
/* Struktur gecastet werden. */

struct studenten {
	int matrnr;
	char name[100];
};

struct tree {
	void *element;
	struct tree *left;
	struct tree *right;
};

void insert(struct tree * *t, struct studenten s) {
	if ((*t) == NULL) {
		(*t) = (struct tree*)calloc(sizeof(struct tree), 1);
		(*t)->element = calloc(sizeof(struct studenten), 1);
		*(struct studenten *)((*t)->element) = s;
		(*t)->left = NULL;
		(*t)->right = NULL;
	}
	else if (s.matrnr <= ((struct studenten *) ((*t)->element) )->matrnr) {
		insert(&((*t)->left), s);
	}
	else {
		insert(&((*t)->right), s);
	}
}

void print(struct tree *t) {
	if (t != NULL) {
		print(t->left);
        printf("%d:", ((struct studenten *)t->element)->matrnr);
        printf("%s", ((struct studenten *)t->element)->name);
		print(t->right);
	}
}

int main() {

	struct tree *root = NULL;

	struct studenten studis;

    char *token;
    char buf[30];
    FILE *fp = NULL;
	int counter = 0;

    if (!(fp = fopen("studis.txt", "r"))) {
        fprintf(stderr, "ERROR: FILE OPEN");
        return 1;
    }

    while (fgets(buf, 30, fp) > 0) {
        token = strtok(buf, ":");
        sscanf(token, "%d", &(studis.matrnr));
        token = strtok(NULL, ":");
        strcpy(studis.name, token);
        insert(&root, studis);
		counter++;
    }

    printf("Nach Matrikelnummer sortiert:\n");

	print(root);

	return 0;

}
