#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Ein Loesung sind Arrays. Hier wird Platz fuer jeden Studenten */
/* geschaffen. Allerdings muss die Groesse des Arrays "im voraus" */
/* festgelegt werden. D.h. auch wenn nur 2 Studenten eingelesen */
/* werden, ist in diesem Beispiel fuer 100 Studenten Speicherplatz */
/* reserviert. Damit diese ueberfluessige Vergeudung von Speicher */
/* vermieden wird, sollte der Speicherplatz dynamisch angelegt */
/* werden (calloc). */

struct studenten {
	int matrnr;
	char name[100];
};

struct tree {
	void *element;
	struct tree *left;
	struct tree *right;
};

void insert(struct tree * *t, struct studenten *s) {
	if ((*t) == NULL) {
		(*t) = (struct tree*)calloc(sizeof(struct tree), 1);
		(struct studenten *)((*t)->element) = s;
		(*t)->left = NULL;
		(*t)->right = NULL;
	}
	else if ((*s).matrnr <= ((struct studenten *) ((*t)->element) )->matrnr) {
		insert(&((*t)->left), s);
	}
	else {
		insert(&((*t)->right), s);
	}
}

void print(struct tree *t) {
	if (t != NULL) {
		print(t->left);
        printf("%d:", ((struct studenten *)t->element)->matrnr);
        printf("%s", ((struct studenten *)t->element)->name);
		print(t->right);
	}
}

int main() {

	struct tree *root = NULL;

	struct studenten studis[100];

    char *token;
    char buf[30];
    FILE *fp = NULL;
	int counter;

    if (!(fp = fopen("studis.txt", "r"))) {
        fprintf(stderr, "ERROR: FILE OPEN");
        return 1;
    }

	counter = 0;
    while (fgets(buf, 30, fp) > 0) {
        token = strtok(buf, ":");
        sscanf(token, "%d", &(studis[counter].matrnr));
        token = strtok(NULL, ":");
        strcpy(studis[counter].name, token);
        insert(&root, &studis[counter]);
		counter++;
    }

    printf("Nach Matrikelnummer sortiert:\n");

	print(root);

	return 0;

}
