#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Damit in der Insert-Funktion die letzten Casts (Vergleiche */
/* Matrikelnummer mit dem entsprechenden Knotenwert) ersetzt */
/* werden koennen, werden separate Vergleichsfunktionen */
/* implementiert, die der Insert-Funktion schliesslich als */
/* Funktionszeiger uebergeben werden. */

typedef int(*CmpFkt)(const void *, const void *);

struct studenten {
	int matrnr;
	char name[100];
};

struct tree {
	void *element;
	struct tree *left;
	struct tree *right;
};

int cmpmatrnr(const void *s1, const void *s2) {
    const struct studenten *t1 = s1;
    const struct studenten *t2 = s2;
    return t1->matrnr - t2->matrnr;
/*    return ((struct studenten *)s1)->matrnr -
        ((struct studenten *)s2)->matrnr; */
}

int cmpname(const void *s1, const void *s2) {
    const struct studenten *t1 = s1;
    const struct studenten *t2 = s2;

    /* n1 = Nachname von Student 1 */
    /* n2 = Nachname von Student 2 */
    char *n1 = strrchr(t1->name, ' ');
    char *n2 = strrchr(t2->name, ' ');

    /* Nachname vergleichen */
    int tmp = strcmp(n1, n2);

    /* Falls Nachnamen verschieden Vergleichswert zurueckgeben */
    if (tmp != 0)
        return tmp;
    /* Sonst die kompletten Namen vergleiche (Vor- und Nachname) */
    /* und den Vergleichswet zurueckgeben. */
    return strcmp(t1->name, t2->name);
}

void insert(struct tree * *t, void *s, CmpFkt cmp) {
	if ((*t) == NULL) {
		(*t) = (struct tree*)calloc(sizeof(struct tree), 1);
		(*t)->element = s;
		(*t)->left = NULL;
		(*t)->right = NULL;
	}
    else if ( (*cmp)(s, (*t)->element) <= 0 ) {
        insert(&((*t)->left), s, cmp);
	}
	else {
		insert(&((*t)->right), s, cmp);
	}
}

void print(struct tree *t) {
	if (t != NULL) {
		print(t->left);
        printf("%d:", ((struct studenten *)t->element)->matrnr);
        printf("%s", ((struct studenten *)t->element)->name);
		print(t->right);
	}
}

int main() {

	struct tree *root = NULL;

	struct studenten studis;
	struct studenten *p;

    char *token;
    char buf[30];
    FILE *fp = NULL;

    if (!(fp = fopen("studis.txt", "r"))) {
        fprintf(stderr, "ERROR: FILE OPEN");
        return 1;
    }

    while (fgets(buf, 30, fp) > 0) {
        token = strtok(buf, ":");
        sscanf(token, "%d", &(studis.matrnr));
        token = strtok(NULL, ":");
        strcpy(studis.name, token);
		p = calloc(1, sizeof(struct studenten));
		*p = studis;
        insert(&root, p, cmpmatrnr);
    }

    printf("Nach Matrikelnummer sortiert:\n");

	print(root);

	return 0;

}
